/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPins(void); /* Function assigned for the Cortex-M0P */

#define IOCON_PIO_CLKDIV0 0x00u      /*!<@brief IOCONCLKDIV0 */
#define IOCON_PIO_HYS_EN 0x20u       /*!<@brief Enable hysteresis */
#define IOCON_PIO_INV_DI 0x00u       /*!<@brief Input not invert */
#define IOCON_PIO_MODE_INACT 0x00u   /*!<@brief No addition pin function */
#define IOCON_PIO_OD_DI 0x00u        /*!<@brief Disables Open-drain function */
#define IOCON_PIO_SMODE_BYPASS 0x00u /*!<@brief Bypass input filter */

/*! @name PIO1_0 (number 11), LD1[3]/CN1[31]/PIO1_0/CAPT_X1
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITLEDSPINS_LED_GREEN_GPIO GPIO                /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_GREEN_GPIO_PIN_MASK (1U << 0U) /*!<@brief GPIO pin mask */
#define BOARD_INITLEDSPINS_LED_GREEN_PORT 1U                  /*!<@brief PORT device index: 1 */
#define BOARD_INITLEDSPINS_LED_GREEN_PIN 0U                   /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_GREEN_PIN_MASK (1U << 0U)      /*!<@brief PORT pin mask */
                                                              /* @} */

/*! @name PIO1_2 (number 16), LD1[2]/CN1[29]/PIO1_2/CAPT_X3
  @{ */
#define BOARD_INITLEDSPINS_LED_RED_PORT 1U                  /*!<@brief PORT device index: 1 */
#define BOARD_INITLEDSPINS_LED_RED_PIN 2U                   /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_RED_PIN_MASK (1U << 2U)      /*!<@brief PORT pin mask */
                                                            /* @} */

/*! @name PIO1_1 (number 14), LD1[4]/CN1[30]/PIO1_1/CAPT_X2
  @{ */
#define BOARD_INITLEDSPINS_LED_BLUE_PORT 1U                  /*!<@brief PORT device index: 1 */
#define BOARD_INITLEDSPINS_LED_BLUE_PIN 1U                   /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_BLUE_PIN_MASK (1U << 1U)      /*!<@brief PORT pin mask */
                                                             /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitLEDsPins(void); /* Function assigned for the Cortex-M0P */

#define IOCON_PIO_CLKDIV0 0x00u      /*!<@brief IOCONCLKDIV0 */
#define IOCON_PIO_HYS_EN 0x20u       /*!<@brief Enable hysteresis */
#define IOCON_PIO_INV_DI 0x00u       /*!<@brief Input not invert */
#define IOCON_PIO_MODE_PULLUP 0x10u  /*!<@brief Selects pull-up function */
#define IOCON_PIO_OD_DI 0x00u        /*!<@brief Disables Open-drain function */
#define IOCON_PIO_SMODE_BYPASS 0x00u /*!<@brief Bypass input filter */

/*! @name PIO0_25 (number 19), CN1[11]/PIO0_25
  @{ */
/*!
 * @brief PORT device index: 0 */
#define BOARD_INITDEBUG_UARTPINS_DEBUG_UART_TX_PORT 0U
/*!
 * @brief PORT pin number */
#define BOARD_INITDEBUG_UARTPINS_DEBUG_UART_TX_PIN 25U
/*!
 * @brief PORT pin mask */
#define BOARD_INITDEBUG_UARTPINS_DEBUG_UART_TX_PIN_MASK (1U << 25U)
/* @} */

/*! @name PIO0_24 (number 20), CN1[10]/PIO0_24
  @{ */
/*!
 * @brief PORT device index: 0 */
#define BOARD_INITDEBUG_UARTPINS_DEBUG_UART_RX_PORT 0U
/*!
 * @brief PORT pin number */
#define BOARD_INITDEBUG_UARTPINS_DEBUG_UART_RX_PIN 24U
/*!
 * @brief PORT pin mask */
#define BOARD_INITDEBUG_UARTPINS_DEBUG_UART_RX_PIN_MASK (1U << 24U)
/* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitDEBUG_UARTPins(void); /* Function assigned for the Cortex-M0P */

#define IOCON_PIO_CLKDIV0 0x00u      /*!<@brief IOCONCLKDIV0 */
#define IOCON_PIO_HYS_EN 0x20u       /*!<@brief Enable hysteresis */
#define IOCON_PIO_INV_DI 0x00u       /*!<@brief Input not invert */
#define IOCON_PIO_MODE_PULLUP 0x10u  /*!<@brief Selects pull-up function */
#define IOCON_PIO_OD_DI 0x00u        /*!<@brief Disables Open-drain function */
#define IOCON_PIO_SMODE_BYPASS 0x00u /*!<@brief Bypass input filter */

/*! @name RESETN (number 5), K2/CN3[10]/CN1[9]/CN1[34]/RESET/PIO0_5
  @{ */
#define BOARD_INITSWD_DEBUGPINS_K2_PORT 0U                  /*!<@brief PORT device index: 0 */
#define BOARD_INITSWD_DEBUGPINS_K2_PIN 5U                   /*!<@brief PORT pin number */
#define BOARD_INITSWD_DEBUGPINS_K2_PIN_MASK (1U << 5U)      /*!<@brief PORT pin mask */
                                                            /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitSWD_DEBUGPins(void); /* Function assigned for the Cortex-M0P */

#define IOCON_PIO_CLKDIV0 0x00u      /*!<@brief IOCONCLKDIV0 */
#define IOCON_PIO_HYS_EN 0x20u       /*!<@brief Enable hysteresis */
#define IOCON_PIO_INV_DI 0x00u       /*!<@brief Input not invert */
#define IOCON_PIO_MODE_PULLUP 0x10u  /*!<@brief Selects pull-up function */
#define IOCON_PIO_OD_DI 0x00u        /*!<@brief Disables Open-drain function */
#define IOCON_PIO_SMODE_BYPASS 0x00u /*!<@brief Bypass input filter */

/*! @name PIO0_4 (number 6), K3/CN1[35]/PIO0_4/ADC_11/TRSTN/WAKEUP
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITBUTTONSPINS_K3_GPIO GPIO                /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITBUTTONSPINS_K3_GPIO_PIN_MASK (1U << 4U) /*!<@brief GPIO pin mask */
#define BOARD_INITBUTTONSPINS_K3_PORT 0U                  /*!<@brief PORT device index: 0 */
#define BOARD_INITBUTTONSPINS_K3_PIN 4U                   /*!<@brief PORT pin number */
#define BOARD_INITBUTTONSPINS_K3_PIN_MASK (1U << 4U)      /*!<@brief PORT pin mask */
                                                          /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitBUTTONsPins(void); /* Function assigned for the Cortex-M0P */

#define IOCON_PIO_CLKDIV0 0x00u      /*!<@brief IOCONCLKDIV0 */
#define IOCON_PIO_HYS_EN 0x20u       /*!<@brief Enable hysteresis */
#define IOCON_PIO_INV_DI 0x00u       /*!<@brief Input not invert */
#define IOCON_PIO_MODE_INACT 0x00u   /*!<@brief No addition pin function */
#define IOCON_PIO_OD_DI 0x00u        /*!<@brief Disables Open-drain function */
#define IOCON_PIO_SMODE_BYPASS 0x00u /*!<@brief Bypass input filter */

/*! @name CAPT_YL (number 1), S1/PIO1_8/CAPT_YL
  @{ */
#define BOARD_INITCAPTPINS_CAPY_LOW_PORT 1U                  /*!<@brief PORT device index: 1 */
#define BOARD_INITCAPTPINS_CAPY_LOW_PIN 8U                   /*!<@brief PORT pin number */
#define BOARD_INITCAPTPINS_CAPY_LOW_PIN_MASK (1U << 8U)      /*!<@brief PORT pin mask */
                                                             /* @} */

/*! @name CAPT_YH (number 3), S1/PIO1_9/CAPT_YH
  @{ */
#define BOARD_INITCAPTPINS_CAPY_HIGH_PORT 1U                  /*!<@brief PORT device index: 1 */
#define BOARD_INITCAPTPINS_CAPY_HIGH_PIN 9U                   /*!<@brief PORT pin number */
#define BOARD_INITCAPTPINS_CAPY_HIGH_PIN_MASK (1U << 9U)      /*!<@brief PORT pin mask */
                                                              /* @} */

/*! @name CAPT_X0 (number 9), S1/PIO0_31/CAPT_X0
  @{ */
#define BOARD_INITCAPTPINS_CAPX_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITCAPTPINS_CAPX_PIN 31U                   /*!<@brief PORT pin number */
#define BOARD_INITCAPTPINS_CAPX_PIN_MASK (1U << 31U)      /*!<@brief PORT pin mask */
                                                          /* @} */

/*! @name ACMP_I5 (number 42), S1/PIO0_30/ACMP_I5
  @{ */
#define BOARD_INITCAPTPINS_CAPY_R_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITCAPTPINS_CAPY_R_PIN 30U                   /*!<@brief PORT pin number */
#define BOARD_INITCAPTPINS_CAPY_R_PIN_MASK (1U << 30U)      /*!<@brief PORT pin mask */
                                                            /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitCAPTPins(void); /* Function assigned for the Cortex-M0P */

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
