/*
 * Copyright 2016-2023 NXP
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of NXP Semiconductor, Inc. nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * @file    LPC845_Project.c
 * @brief   Application entry point.
 */
#include <stdio.h>
#include "board.h"
#include "peripherals.h"
#include "pin_mux.h"
#include "clock_config.h"
#include "LPC845.h"
#include "fsl_debug_console.h"
/* TODO: insert other include files here. */
#include "fsl_usart.h"
#include "USART.h"

/* TODO: insert other definitions and declarations here. */

#define COMD_LED_ON '1'
#define COMD_LED_OFF '0'
/*
 * @brief   Application entry point.
 */

int main(void) {
uint8_t rxdata;
#define LenMax 32
char str_out[64];
char str_in[LenMax];
float PI =3.1415;
float e = 2.7182;

    /* Init board hardware. */
    BOARD_InitBootPins();
    BOARD_InitBootClocks();
    BOARD_InitBootPeripherals();

/*
#ifndef BOARD_INIT_DEBUG_CONSOLE_PERIPHERAL
     Init FSL debug console.
    BOARD_InitDebugConsole();
#endif
*/

    INIT_USART();
    PrintUSART0_NB("Hello World IT!\r\n");

/* a lebegőpontos számok konvertálása csak akkor működik, ha beállítjuk:
   Project/Properties/C/C++ Build/Settings/MCU Linker/Managed Link Script
   Library: NewlibNano (nohost)
            Enable printf float
*/
    sprintf(str_out, "PI = %.4f\r\n", PI);
    PrintUSART0_NB(str_out);
    sprintf(str_out, "e = %.4f\r\n", e);
    PrintUSART0_NB(str_out);
//uint8_t GetString_TillEndChar(char *str, uint8_t End_Char, uint8_t LenMax, uint8_t reset)
    GetString_TillEndChar(str_in, CR, LenMax, 1);
    do{
    }while(!GetString_TillEndChar(str_in, CR, LenMax, 0));
    PrintUSART0_NB("\r\n");
    PrintUSART0_NB(str_in);

    while(1) {

    	if(GetUSART0(&rxdata))
    	{
    		switch(rxdata)
    		{
    		case COMD_LED_OFF:
    			LED_RED_OFF();
    			break;
    		case COMD_LED_ON:
    			LED_RED_ON();
        		break;
    		}
    	}
    }
    return 0 ;
}
