/*
 * I2C.c
 *
 *  Created on: May 10, 2023
 *      Author: benes
 */

#include "fsl_i2c.h"
#include "I2C.h"



// Write I2C address, reg address, and reg data
uint8_t I2C_RegWrite(uint8_t SLA, uint8_t reg_addr, uint8_t data)
{
	uint8_t err = 0;
	int32_t status;
	I2C_txBuff[0] = reg_addr;
	I2C_txBuff[1] = data;
	status = I2C_MasterStart(I2C0, SLA, kI2C_Write);
	if(status == kStatus_Success)
	{
		status =I2C_MasterWriteBlocking(I2C0, I2C_txBuff, 2, kI2C_TransferDefaultFlag);
		if(status != kStatus_Success){ err = 1; }
	}
	else{ err = 1; }
	//STOP genertated by I2C_MasterWriteBlocking()
	return(err);
}

// Write I2C address, and set reg address
uint8_t I2C_SetRegAddrToRD(uint8_t SLA, uint8_t reg_addr)
{
	uint8_t err = 0;
	int32_t status;
	I2C_txBuff[0] = reg_addr;
	status = I2C_MasterStart(I2C0, SLA, kI2C_Write);
	if(status == kStatus_Success)
	{
		status = I2C_MasterWriteBlocking(I2C0, I2C_txBuff, 1, kI2C_TransferDefaultFlag);
		//STOP genertated by I2C_MasterWriteBlocking()
		if(status != kStatus_Success){ err = 1;}
	}else{ err = 1; }
	return(err);
}

//Write I2C address, set reg address, read reg data
uint8_t I2C_RegReadBuf(uint8_t SLA, uint8_t reag_addr, uint8_t * buff, uint8_t count)
{
	uint32_t flags = 0;
	uint32_t status;
	uint8_t err = 0;
	err = I2C_SetRegAddrToRD(SLA, reag_addr);
	if(!err)
	{
		status = I2C_MasterStart(I2C0, SLA, kI2C_Read);
	}
	if(status == kStatus_Success)
	{
		status = I2C_MasterReadBlocking(I2C0, buff, count, flags);
		if(status != kStatus_Success){ err = 1; }
	}
	else{ err = 1; }
	return(err);
}





